var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var imgbg1png = new Image();
var dayofweekBitmapStrImages = [];
var dayofweekBitmapStrKey = ["am", "pm"];
var dayofweekBitmapStr = ["", ""];
var dayofweekImages = [];
var dayofweekBitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
var imgh1png = new Image();
var imgm1png = new Image();
var imgworldpng = new Image();
var imgi1png = new Image();

var Image2ButtonArea = [8, 104, 107, 170];

var Image3ButtonArea = [9, 193, 108, 259];
var imgp1png = new Image();
var imghpng = new Image();
var imgmpng = new Image();
var imgspng = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    imgbg1png.src = "bg1.png";
    context.drawImage(imgbg1png, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.translate(261, 271);
    context.rotate(53.39292518739251*Math.PI/180);
    context.beginPath();
    context.font = "bold 20px Tizen";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = date.getDate();
    context.fillText(text, 0, 0);
    context.restore();
    context.save();

    text = date.getDay();
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<dayofweekBitmapStr.length; j++) {
                if (tokens[i] === dayofweekBitmapStrKey[j]) {
                    charImage = dayofweekBitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (dayofweekBitmap[strChar - 0x20] !== "") {
                            charImage = dayofweekImages[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 180 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 180 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(130, 236);
    context.rotate(angle);
    imgh1png.src = "h1.png";
    context.drawImage(imgh1png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(130, 236);
    context.rotate(angle);
    imgm1png.src = "m1.png";
    context.drawImage(imgm1png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(257, 180);
    context.rotate(angle);
    imgworldpng.src = "world.png";
    context.drawImage(imgworldpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    imgi1png.src = "i1.png";
    context.drawImage(imgi1png, 0, 0, 360, 360);
    context.restore();
    context.save();

    gImage.src = "app.png";
    context.drawImage(imgapppng, 8, 104, 99, 66);
    context.restore();
    context.save();

    gImage.src = "app.png";
    context.drawImage(imgapppng, 9, 193, 99, 66);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((Math.floor(battery.level*100) - 0.000000) / (100.000000 - 0.000000))))*Math.PI/180;
    context.translate(258, 180);
    context.rotate(angle);
    imgp1png.src = "p1.png";
    context.drawImage(imgp1png, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imghpng.src = "h.png";
    context.drawImage(imghpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgmpng.src = "m.png";
    context.drawImage(imgmpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgspng.src = "s.png";
    context.drawImage(imgspng, -180, -180, 360, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

    var i;
    for (i = 0; i<95; i++) {
        if (dayofweekBitmap[i] !== "") {
            dayofweekImages[i] = new Image();
            dayofweekImages[i].src = "res/fonts/bitmap_1/" + dayofweekBitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (dayofweekBitmapStr[i] !== "") {
            dayofweekBitmapStrImages[i] = new Image();
            dayofweekBitmapStrImages[i].src = "res/fonts/bitmap_1/" + dayofweekBitmapStr[i];
        }
    }
    window.addEventListener('touchstart', function (e) {
        if (e.changedTouches[0].clientX >= Image2ButtonArea[0] && e.changedTouches[0].clientX < Image2ButtonArea[2] && e.changedTouches[0].clientY >= Image2ButtonArea[1] && e.changedTouches[0].clientY < Image2ButtonArea[3]) {
            tizen.application.launch("com.samsung.clocksetting");
        }
        if (e.changedTouches[0].clientX >= Image3ButtonArea[0] && e.changedTouches[0].clientX < Image3ButtonArea[2] && e.changedTouches[0].clientY >= Image3ButtonArea[1] && e.changedTouches[0].clientY < Image3ButtonArea[3]) {
            tizen.application.launch("battery");
        }
    });
};
